#! /usr/bin/perl

push(@INC, grep(-f "$_/tfm.pl", split(/:/,$ENV{'PATH'})));
require 'tfm.pl';

# (x,y,z, nearbyraradians) -> ("hh:mm.m", "+dd:mm.m", distance, raradians)
sub eqref2dms {
  local($r, $rxy);
  local(@eq) = @_;
  local($ra, $dec);
  $rxy = sqrt($eq[0]*$eq[0] + $eq[1]*$eq[1]);
  $dec = atan2($eq[2], $rxy);
  $ra = atan2($eq[1], $eq[0]);
  local($raref) = $eq[3] ne "" ? $eq[3] : $pi;
  $ra += 2*$pi if($ra - $raref < -$pi*1.001);
  $ra -= 2*$pi if($ra - $raref > $pi*1.001);
  return(&rad2dms($ra/15), &rad2dms($dec,"+"), $ra);
}

$glonref = "";
while(<>) {
    if(/^(\d\d)(\d\d)(\d\d)([-+]\d\d)(\d\d)(.*)/) {
	($ah,$am,$as, $dsdd,$dm,$rest) = ($1,$2,$3,$4,$5,$6);
	@eqv = &radec2eq( "$ah:$am:$as", "$dsdd:$dm", 1 );
	@galv = &vm3mul( @eqv, @Teg );
	($glon, $glat, $thislon) = &eq2dms( @galv, $glonref );
	$glonref = $thislon if $rest =~ /Vs|VM/;
	
	printf "%s%s%02d%s%s%s\n",
		substr($glon,1,2), substr($glon,4,2),
		substr($glon,7,1) * 6,
		substr($glat,0,3), substr($glat,4,2),
		$rest;
    } else {
	print;
    }
}
